>From 1b28037fcf192f41bc7c63253762990538966200 Mon Sep 17 00:00:00 2001
From: Adam Young <ayoung@redhat.com>
Date: Sat, 10 Dec 2011 21:29:06 -0500
Subject: [PATCH] Simple Name Instead of Extensions using a specified NAME
 field they now use the SimpleName of the class. In most
 cases,  this either matches what was used before,  or adds
 the Words "Extension" on to the end of it.

Fixed the Name for Generic Extensions

https://fedorahosted.org/pki/ticket/2
---
 pki/.gitignore                                     |    5 +
 pki/base/ca/src/com/netscape/ca/CAService.java     |   41 +-
 .../ca/src/com/netscape/ca/CMSCRLExtensions.java   |   74 ++--
 .../ca/src/com/netscape/ca/CRLIssuingPoint.java    |   26 +-
 .../src/com/netscape/ca/CertificateAuthority.java  |   41 +-
 .../common/src/com/netscape/certsrv/apps/CMS.java  |   20 +-
 .../src/com/netscape/certsrv/apps/ICMSEngine.java  |   20 +-
 .../netscape/certsrv/authentication/AuthToken.java |    8 +-
 .../certsrv/authentication/IAuthToken.java         |    2 +-
 .../src/com/netscape/certsrv/base/MetaInfo.java    |    6 +-
 .../com/netscape/certsrv/ca/ICRLIssuingPoint.java  |    5 +-
 .../certsrv/logging/ILogEventListener.java         |    8 +-
 .../src/com/netscape/certsrv/request/IRequest.java |   11 +-
 .../cms/authentication/DirBasedAuthentication.java |   14 +-
 .../SSLclientCertAuthentication.java               |    2 +-
 .../common/src/com/netscape/cms/ocsp/DefStore.java |   45 +-
 .../constraints/UniqueSubjectNameConstraints.java  |   14 +-
 .../cms/policy/extensions/AuthInfoAccessExt.java   |   27 +-
 .../extensions/AuthorityKeyIdentifierExt.java      |   16 +-
 .../cms/policy/extensions/BasicConstraintsExt.java |   20 +-
 .../extensions/CRLDistributionPointsExt.java       |   20 +-
 .../policy/extensions/CertificatePoliciesExt.java  |   22 +-
 .../extensions/CertificateRenewalWindowExt.java    |   12 +-
 .../extensions/CertificateScopeOfUseExt.java       |   16 +-
 .../cms/policy/extensions/ExtendedKeyUsageExt.java |   18 +-
 .../cms/policy/extensions/GenericASN1Ext.java      |   14 +-
 .../cms/policy/extensions/IssuerAltNameExt.java    |   14 +-
 .../cms/policy/extensions/KeyUsageExt.java         |   12 +-
 .../cms/policy/extensions/NSCCommentExt.java       |   12 +-
 .../cms/policy/extensions/NSCertTypeExt.java       |   16 +-
 .../cms/policy/extensions/NameConstraintsExt.java  |   26 +-
 .../cms/policy/extensions/OCSPNoCheckExt.java      |   12 +-
 .../policy/extensions/PolicyConstraintsExt.java    |   12 +-
 .../cms/policy/extensions/PolicyMappingsExt.java   |   20 +-
 .../cms/policy/extensions/PresenceExt.java         |    8 +-
 .../extensions/PrivateKeyUsagePeriodExt.java       |   16 +-
 .../extensions/RemoveBasicConstraintsExt.java      |   10 +-
 .../cms/policy/extensions/SubjAltNameExt.java      |   24 +-
 .../cms/policy/extensions/SubjectAltNameExt.java   |   20 +-
 .../extensions/SubjectDirectoryAttributesExt.java  |   29 +-
 .../policy/extensions/SubjectKeyIdentifierExt.java |   14 +-
 .../netscape/cms/profile/common/EnrollProfile.java |    4 +-
 .../cms/profile/constraint/EnrollConstraint.java   |    8 +-
 .../constraint/UniqueSubjectNameConstraint.java    |   10 +-
 .../def/CRLDistributionPointsExtDefault.java       |    8 +-
 .../profile/def/CertificatePoliciesExtDefault.java |   29 +-
 .../netscape/cms/profile/def/EnrollDefault.java    |   36 +-
 .../cms/profile/def/FreshestCRLExtDefault.java     |    8 +-
 .../cms/profile/def/IssuerAltNameExtDefault.java   |    2 +-
 .../cms/profile/def/NameConstraintsExtDefault.java |   24 +-
 .../cms/profile/def/PolicyMappingsExtDefault.java  |   14 +-
 .../cms/profile/def/SubjectAltNameExtDefault.java  |   10 +-
 .../def/SubjectDirAttributesExtDefault.java        |   26 +-
 .../netscape/cms/publish/mappers/AVAPattern.java   |    7 +-
 .../cms/publish/mappers/LdapCaSimpleMap.java       |    8 +-
 .../cms/publish/mappers/LdapEnhancedMap.java       |   10 +-
 .../cms/publish/mappers/LdapSimpleMap.java         |    8 +-
 .../cms/publish/mappers/MapAVAPattern.java         |    7 +-
 .../netscape/cms/publish/mappers/MapDNPattern.java |    6 +-
 .../cms/publish/mappers/MapRDNPattern.java         |    6 +-
 .../publishers/LdapEncryptCertPublisher.java       |   23 +-
 .../cms/servlet/admin/CMSAdminServlet.java         |   83 ++-
 .../com/netscape/cms/servlet/base/CMSServlet.java  |   44 +-
 .../cms/servlet/cert/CMCRevReqServlet.java         |   12 +-
 .../servlet/cert/ChallengeRevocationServlet1.java  |   12 +-
 .../netscape/cms/servlet/cert/DisplayBySerial.java |    2 +-
 .../com/netscape/cms/servlet/cert/DoRevoke.java    |   14 +-
 .../com/netscape/cms/servlet/cert/DoRevokeTPS.java |   10 +-
 .../netscape/cms/servlet/cert/EnrollServlet.java   |    6 +-
 .../cms/servlet/cert/HashEnrollServlet.java        |   12 +-
 .../com/netscape/cms/servlet/cert/ListCerts.java   |   12 +-
 .../com/netscape/cms/servlet/cert/SrchCerts.java   |    8 +-
 .../com/netscape/cms/servlet/cert/UpdateCRL.java   |   11 +-
 .../cms/servlet/cert/scep/CRSEnrollment.java       |   84 ++--
 .../cms/servlet/cert/scep/ChallengePassword.java   |    6 +-
 .../cms/servlet/cert/scep/ExtensionsRequested.java |    9 +-
 .../cms/servlet/common/CMCOutputTemplate.java      |    4 +-
 .../cms/servlet/connector/ConnectorServlet.java    |    4 +-
 .../cms/servlet/profile/ProfileSubmitServlet.java  |   51 +-
 .../cms/servlet/request/CertReqParser.java         |   51 +-
 .../cms/servlet/request/ProcessCertReq.java        |   17 +-
 .../src/com/netscape/cmscore/apps/CMSEngine.java   |   45 +-
 .../src/com/netscape/cmscore/cert/CertUtils.java   |    2 +-
 .../netscape/cmscore/cert/CrlCachePrettyPrint.java |    8 +-
 .../netscape/cmscore/cert/OidLoaderSubsystem.java  |   16 +-
 .../netscape/cmscore/dbs/RevocationInfoMapper.java |   12 +-
 .../netscape/cmscore/dbs/X509CertImplMapper.java   |   20 +-
 .../cmscore/extensions/CMSExtensionsMap.java       |    6 +-
 .../notification/ReqCertSANameEmailResolver.java   |   12 +-
 .../netscape/cmscore/request/ARequestQueue.java    |   80 ++--
 .../netscape/cmscore/request/ExtDataHashtable.java |   18 +-
 .../netscape/cmscore/security/CertificateInfo.java |    4 +-
 .../netscape/cmscore/security/JssSubsystem.java    |   56 +-
 .../com/netscape/cmscore/security/KeyCertUtil.java |   23 +-
 .../netscape/certsrv/app/CMSEngineDefaultStub.java |   82 ++-
 .../cmscore/request/ExtDataHashtableTest.java      |   10 +-
 .../cmscore/request/RequestDefaultStub.java        |   12 +-
 .../com/netscape/cmscore/request/RequestTest.java  |   60 +-
 .../src/com/netscape/cmstools/GenExtKeyUsage.java  |    4 +-
 .../src/com/netscape/cmstools/PrettyPrintCert.java |    2 +-
 .../src/com/netscape/cmstools/PrettyPrintCrl.java  |    8 +-
 .../com/netscape/pkisilent/common/Utilities.java   |   10 +-
 .../com/netscape/cmsutil/crypto/CryptoUtil.java    |   10 +-
 .../com/netscape/cmsutil/scep/CRSPKIMessage.java   |   16 +-
 .../extensions/AuthInfoAccessExtension.java        |   21 +-
 .../CertificateRenewalWindowExtension.java         |   10 +-
 .../extensions/CertificateScopeOfUseExtension.java |   14 +-
 .../extensions/ExtendedKeyUsageExtension.java      |   24 +-
 .../security/extensions/GenericASN1Extension.java  |   27 +-
 .../extensions/InhibitAnyPolicyExtension.java      |    8 +-
 .../netscape/security/extensions/KerberosName.java |    6 +-
 .../security/extensions/NSCertTypeExtension.java   |   11 +-
 .../security/extensions/OCSPNoCheckExtension.java  |    9 +-
 .../extensions/PresenceServerExtension.java        |    9 +-
 .../extensions/SubjectInfoAccessExtension.java     |   21 +-
 .../netscape/security/pkcs/PKCS10Attribute.java    |    9 +-
 .../src/netscape/security/pkcs/PKCS9Attribute.java |   14 +-
 .../security/provider/X509CertificateFactory.java  |    4 +-
 .../src/netscape/security/util/CrlPrettyPrint.java |    9 +-
 .../src/netscape/security/util/ExtPrettyPrint.java |   19 +-
 .../src/netscape/security/x509/ACertAttrSet.java   |    2 +-
 .../x509/AuthorityKeyIdentifierExtension.java      |    9 +-
 .../security/x509/BasicConstraintsExtension.java   |    9 +-
 .../x509/CRLDistributionPointsExtension.java       |   28 +-
 .../netscape/security/x509/CRLNumberExtension.java |    9 +-
 .../netscape/security/x509/CRLReasonExtension.java |    9 +-
 .../src/netscape/security/x509/CertAttrSet.java    |    3 +-
 .../security/x509/CertificateAlgorithmId.java      |    2 +-
 .../security/x509/CertificateExtensions.java       |   34 +-
 .../security/x509/CertificateIssuerExtension.java  |   11 +-
 .../security/x509/CertificateIssuerName.java       |    2 +-
 .../x509/CertificateIssuerUniqueIdentity.java      |    2 +-
 .../x509/CertificatePoliciesExtension.java         |   43 +-
 .../security/x509/CertificateSerialNumber.java     |    2 +-
 .../security/x509/CertificateSubjectName.java      |    2 +-
 .../x509/CertificateSubjectUniqueIdentity.java     |    2 +-
 .../security/x509/CertificateValidity.java         |    2 +-
 .../netscape/security/x509/CertificateVersion.java |    2 +-
 .../netscape/security/x509/CertificateX509Key.java |    2 +-
 .../security/x509/DeltaCRLIndicatorExtension.java  |   11 +-
 .../util/src/netscape/security/x509/Extension.java |    5 +
 .../src/netscape/security/x509/Extensions.java     |   29 +-
 .../security/x509/FreshestCRLExtension.java        |   27 +-
 .../security/x509/HoldInstructionExtension.java    |   11 +-
 .../security/x509/InvalidityDateExtension.java     |   11 +-
 .../x509/IssuerAlternativeNameExtension.java       |    9 +-
 .../x509/IssuingDistributionPointExtension.java    |   11 +-
 .../netscape/security/x509/KeyUsageExtension.java  |    9 +-
 .../security/x509/NSCCommentExtension.java         |   22 +-
 .../security/x509/NameConstraintsExtension.java    |    9 +-
 .../util/src/netscape/security/x509/OIDMap.java    |   56 +-
 .../security/x509/PolicyConstraintsExtension.java  |    9 +-
 .../security/x509/PolicyMappingsExtension.java     |   28 +-
 .../security/x509/PrivateKeyUsageExtension.java    |   10 +-
 .../netscape/security/x509/RevokedCertImpl.java    |  680 ++++++++++----------
 .../netscape/security/x509/RevokedCertificate.java |    5 +
 .../x509/SubjectAlternativeNameExtension.java      |    9 +-
 .../x509/SubjectDirAttributesExtension.java        |   25 +-
 .../x509/SubjectKeyIdentifierExtension.java        |    9 +-
 .../src/netscape/security/x509/X509CertImpl.java   |   24 +-
 .../src/netscape/security/x509/X509CertInfo.java   |    2 +-
 161 files changed, 1645 insertions(+), 1730 deletions(-)

diff --git a/pki/.gitignore b/pki/.gitignore
index dc84959d1dcee0eb0a0a0a34dda9b3489debcb8d..aa25dac5dae3458d010b4c17f91c551486210d21 100644
--- a/pki/.gitignore
+++ b/pki/.gitignore
@@ -1,2 +1,7 @@
+pki/build/
+.metadata/
 build/
+packages.*/
+packages/
+
 
diff --git a/pki/base/ca/src/com/netscape/ca/CAService.java b/pki/base/ca/src/com/netscape/ca/CAService.java
index 159539d453b78c9a89a3a3cc571f743459b95f17..64fd73e490c0521e0ad33d760401d1ad8531fbad 100644
--- a/pki/base/ca/src/com/netscape/ca/CAService.java
+++ b/pki/base/ca/src/com/netscape/ca/CAService.java
@@ -46,6 +46,7 @@ import netscape.security.x509.CertificateIssuerName;
 import netscape.security.x509.CertificateSerialNumber;
 import netscape.security.x509.CertificateSubjectName;
 import netscape.security.x509.CertificateValidity;
+import netscape.security.x509.Extension;
 import netscape.security.x509.LdapV3DNStrConverter;
 import netscape.security.x509.PKIXExtensions;
 import netscape.security.x509.RevocationReason;
@@ -106,11 +107,11 @@ public class CAService implements ICAService, IService {
     protected static IConnector mCLAConnector = null;
 
     private ICertificateAuthority mCA = null;
-    private Hashtable mServants = new Hashtable();
+    private Hashtable<String, IServant> mServants = new Hashtable<String, IServant>();
     private IConnector mKRAConnector = null;
     private IConfigStore mConfig = null;
     private boolean mArchivalRequired = true;
-    private Hashtable mCRLIssuingPoints = new Hashtable();
+    private Hashtable<String, ICRLIssuingPoint> mCRLIssuingPoints = new Hashtable<String, ICRLIssuingPoint>();
 
     private ILogger mSignedAuditLogger = CMS.getSignedAuditLogger();
     private final static String
@@ -533,7 +534,7 @@ public class CAService implements ICAService, IService {
     /**
      * get CRL Issuing Point
      */
-    public Hashtable getCRLIssuingPoints() {
+    public Hashtable<String, ICRLIssuingPoint> getCRLIssuingPoints() {
         return mCRLIssuingPoints;
     }
 
@@ -686,7 +687,7 @@ public class CAService implements ICAService, IService {
                 exts = (CertificateExtensions)
                     certi.get(X509CertInfo.EXTENSIONS);
                 if (exts != null) {
-                    Enumeration e = exts.getElements();
+                    Enumeration<Extension> e = exts.getAttributes();
 
                     while (e.hasMoreElements()) {
                         netscape.security.x509.Extension ext = (netscape.security.x509.Extension) e.nextElement();
@@ -921,7 +922,7 @@ public class CAService implements ICAService, IService {
                 } else {
                     if (Debug.ON) {
                         System.out.println("Old meta info");
-                        Enumeration n = oldMeta.getElements();
+                        Enumeration<String> n = oldMeta.getElements();
 
                         while (n.hasMoreElements()) {
                             String name = (String) n.nextElement();
@@ -947,7 +948,7 @@ public class CAService implements ICAService, IService {
                         mCA.getCertificateRepository().readCertificateRecord(oldSerialNo);
                     MetaInfo meta = check.getMetaInfo();
 
-                    Enumeration n = oldMeta.getElements();
+                    Enumeration<String> n = oldMeta.getElements();
 
                     while (n.hasMoreElements()) {
                         String name = (String) n.nextElement();
@@ -994,7 +995,7 @@ public class CAService implements ICAService, IService {
         if (exts != null) {
             try {
                 reasonext = (CRLReasonExtension)
-                        exts.get(CRLReasonExtension.NAME);
+                        exts.get(CRLReasonExtension.class.getSimpleName());
             } catch (X509ExtensionException e) {
                 // this means no crl reason extension set.
             }
@@ -1013,7 +1014,7 @@ public class CAService implements ICAService, IService {
             mCA.log(ILogger.LL_INFO, CMS.getLogMessage("CMSCORE_CA_CERT_REVOKED",
                     serialno.toString(16)));
             // inform all CRLIssuingPoints about revoked certificate
-            Enumeration eIPs = mCRLIssuingPoints.elements();
+            Enumeration<ICRLIssuingPoint> eIPs = mCRLIssuingPoints.elements();
 
             while (eIPs.hasMoreElements()) {
                 ICRLIssuingPoint ip = (ICRLIssuingPoint) eIPs.nextElement();
@@ -1077,7 +1078,7 @@ public class CAService implements ICAService, IService {
         if (exts != null) {
             try {
                 reasonext = (CRLReasonExtension)
-                        exts.get(CRLReasonExtension.NAME);
+                        exts.get(CRLReasonExtension.class.getSimpleName());
             } catch (X509ExtensionException e) {
                 mCA.log(ILogger.LL_FAILURE, CMS.getLogMessage("CMSCORE_CA_CERT_ON_HOLD", serialNo.toString())); 
                 throw new ECAException(CMS.getUserMessage("CMS_CA_IS_NOT_ON_HOLD", 
@@ -1098,7 +1099,7 @@ public class CAService implements ICAService, IService {
                     certRec.getRevokedOn(), certRec.getRevokedBy());
                 mCA.log(ILogger.LL_INFO, CMS.getLogMessage("CMSCORE_CA_CERT_UNREVOKED", serialNo.toString(16)));
                 // inform all CRLIssuingPoints about unrevoked certificate
-                Enumeration eIPs = mCRLIssuingPoints.elements();
+                Enumeration<ICRLIssuingPoint> eIPs = mCRLIssuingPoints.elements();
 
                 while (eIPs.hasMoreElements()) {
                     ICRLIssuingPoint ip = (ICRLIssuingPoint) eIPs.nextElement();
@@ -1614,15 +1615,15 @@ class serviceCheckChallenge implements IServant {
                 String filter = "(&(x509cert.subject=" + subjectName + ")(certStatus=VALID))";
                 ICertRecordList list = certDB.findCertRecordsInList(filter, null, 10);
                 int size = list.getSize();
-                Enumeration en = list.getCertRecords(0, size - 1);
+                Enumeration<ICertRecord> en = list.getCertRecords(0, size - 1);
 
                 if (!en.hasMoreElements()) {
                     bigIntArray = new BigInteger[0];
                 } else {
-                    Vector idv = new Vector();
+                    Vector<BigInteger> idv = new Vector<BigInteger>();
 
                     while (en.hasMoreElements()) {
-                        CertRecord record = (CertRecord) en.nextElement();
+                        ICertRecord record =  en.nextElement();
                         boolean samepwd = compareChallengePassword(record, pwd);
 
                         if (samepwd) {
@@ -1644,7 +1645,7 @@ class serviceCheckChallenge implements IServant {
         return true;
     }
 
-    private boolean compareChallengePassword(CertRecord record, String pwd)
+    private boolean compareChallengePassword(ICertRecord record, String pwd)
         throws EBaseException {
         MetaInfo metaInfo = (MetaInfo) record.get(CertRecord.ATTR_META_INFO);
 
@@ -1925,7 +1926,7 @@ class serviceGetRevocationInfo implements IServant {
 
     public boolean service(IRequest request)
         throws EBaseException {
-        Enumeration enum1 = request.getExtDataKeys();
+        Enumeration<String> enum1 = request.getExtDataKeys();
 
         while (enum1.hasMoreElements()) {
             String name = (String) enum1.nextElement();
@@ -1966,7 +1967,7 @@ class serviceGetCertificates implements IServant {
 
     public boolean service(IRequest request)
         throws EBaseException {
-        Enumeration enum1 = request.getExtDataKeys();
+        Enumeration<String> enum1 = request.getExtDataKeys();
 
         while (enum1.hasMoreElements()) {
             String name = (String) enum1.nextElement();
@@ -2034,8 +2035,8 @@ class serviceCert4Crl implements IServant {
                 //				mService.revokeCert(crlentries[i]);
                 recordedCerts[i] = revokedCertRecs[i];
                 // inform all CRLIssuingPoints about revoked certificate
-                Hashtable hips = mService.getCRLIssuingPoints();
-                Enumeration eIPs = hips.elements();
+                Hashtable<String, ICRLIssuingPoint> hips = mService.getCRLIssuingPoints();
+                Enumeration<ICRLIssuingPoint> eIPs = hips.elements();
 
                 while (eIPs.hasMoreElements()) {
                     ICRLIssuingPoint ip = (ICRLIssuingPoint) eIPs.nextElement();
@@ -2096,8 +2097,8 @@ class serviceUnCert4Crl implements IServant {
             try {
                 mCA.getCertificateRepository().deleteCertificateRecord(oldSerialNo[i]);
                 // inform all CRLIssuingPoints about unrevoked certificate
-                Hashtable hips = mService.getCRLIssuingPoints();
-                Enumeration eIPs = hips.elements();
+                Hashtable<String, ICRLIssuingPoint> hips = mService.getCRLIssuingPoints();
+                Enumeration<ICRLIssuingPoint> eIPs = hips.elements();
 
                 while (eIPs.hasMoreElements()) {
                     ICRLIssuingPoint ip = (ICRLIssuingPoint) eIPs.nextElement();
diff --git a/pki/base/ca/src/com/netscape/ca/CMSCRLExtensions.java b/pki/base/ca/src/com/netscape/ca/CMSCRLExtensions.java
index 51d0341798523e88255374191f7020cfd047d61a..8024cd33b19151b31d694a8755d6752400a9bfeb 100644
--- a/pki/base/ca/src/com/netscape/ca/CMSCRLExtensions.java
+++ b/pki/base/ca/src/com/netscape/ca/CMSCRLExtensions.java
@@ -90,75 +90,75 @@ public class CMSCRLExtensions implements ICMSCRLExtensions {
     static {
 
         /* Default CRL Extensions */
-        mDefaultCRLExtensionNames.addElement(AuthorityKeyIdentifierExtension.NAME);
-        mDefaultCRLExtensionNames.addElement(IssuerAlternativeNameExtension.NAME);
-        mDefaultCRLExtensionNames.addElement(CRLNumberExtension.NAME);
-        mDefaultCRLExtensionNames.addElement(DeltaCRLIndicatorExtension.NAME);
-        mDefaultCRLExtensionNames.addElement(IssuingDistributionPointExtension.NAME);
-        mDefaultCRLExtensionNames.addElement(FreshestCRLExtension.NAME);
-        mDefaultCRLExtensionNames.addElement(AuthInfoAccessExtension.NAME2);
+        mDefaultCRLExtensionNames.addElement(AuthorityKeyIdentifierExtension.class.getSimpleName());
+        mDefaultCRLExtensionNames.addElement(IssuerAlternativeNameExtension.class.getSimpleName());
+        mDefaultCRLExtensionNames.addElement(CRLNumberExtension.class.getSimpleName());
+        mDefaultCRLExtensionNames.addElement(DeltaCRLIndicatorExtension.class.getSimpleName());
+        mDefaultCRLExtensionNames.addElement(IssuingDistributionPointExtension.class.getSimpleName());
+        mDefaultCRLExtensionNames.addElement(FreshestCRLExtension.class.getSimpleName());
+        mDefaultCRLExtensionNames.addElement(AuthInfoAccessExtension.class.getSimpleName());
 
         /* Default CRL Entry Extensions */
-        mDefaultCRLEntryExtensionNames.addElement(CRLReasonExtension.NAME);
+        mDefaultCRLEntryExtensionNames.addElement(CRLReasonExtension.class.getSimpleName());
         //mDefaultCRLEntryExtensionNames.addElement(HoldInstructionExtension.NAME);
-        mDefaultCRLEntryExtensionNames.addElement(InvalidityDateExtension.NAME);
+        mDefaultCRLEntryExtensionNames.addElement(InvalidityDateExtension.class.getSimpleName());
         //mDefaultCRLEntryExtensionNames.addElement(CertificateIssuerExtension.NAME);
 
         /* Default Enabled CRL Extensions */
-        mDefaultEnabledCRLExtensions.addElement(CRLNumberExtension.NAME);
+        mDefaultEnabledCRLExtensions.addElement(CRLNumberExtension.class.getSimpleName());
         //mDefaultEnabledCRLExtensions.addElement(DeltaCRLIndicatorExtension.NAME);
-        mDefaultEnabledCRLExtensions.addElement(CRLReasonExtension.NAME);
-        mDefaultEnabledCRLExtensions.addElement(InvalidityDateExtension.NAME);
+        mDefaultEnabledCRLExtensions.addElement(CRLReasonExtension.class.getSimpleName());
+        mDefaultEnabledCRLExtensions.addElement(InvalidityDateExtension.class.getSimpleName());
 
         /* Default Critical CRL Extensions */
-        mDefaultCriticalCRLExtensions.addElement(DeltaCRLIndicatorExtension.NAME);
-        mDefaultCriticalCRLExtensions.addElement(IssuingDistributionPointExtension.NAME);
+        mDefaultCriticalCRLExtensions.addElement(DeltaCRLIndicatorExtension.class.getSimpleName());
+        mDefaultCriticalCRLExtensions.addElement(IssuingDistributionPointExtension.class.getSimpleName());
         //mDefaultCriticalCRLExtensions.addElement(CertificateIssuerExtension.NAME);
 
         /* CRL extension IDs */
         mDefaultCRLExtensionIDs.put(PKIXExtensions.AuthorityKey_Id.toString(),
-            AuthorityKeyIdentifierExtension.NAME);
+            AuthorityKeyIdentifierExtension.class.getSimpleName());
         mDefaultCRLExtensionIDs.put(PKIXExtensions.IssuerAlternativeName_Id.toString(),
-            IssuerAlternativeNameExtension.NAME);
+            IssuerAlternativeNameExtension.class.getSimpleName());
         mDefaultCRLExtensionIDs.put(PKIXExtensions.CRLNumber_Id.toString(),
-            CRLNumberExtension.NAME);
+            CRLNumberExtension.class.getSimpleName());
         mDefaultCRLExtensionIDs.put(PKIXExtensions.DeltaCRLIndicator_Id.toString(),
-            DeltaCRLIndicatorExtension.NAME);
+            DeltaCRLIndicatorExtension.class.getSimpleName());
         mDefaultCRLExtensionIDs.put(PKIXExtensions.IssuingDistributionPoint_Id.toString(),
-            IssuingDistributionPointExtension.NAME);
+            IssuingDistributionPointExtension.class.getSimpleName());
         mDefaultCRLExtensionIDs.put(PKIXExtensions.ReasonCode_Id.toString(),
-            CRLReasonExtension.NAME);
+            CRLReasonExtension.class.getSimpleName());
         mDefaultCRLExtensionIDs.put(PKIXExtensions.HoldInstructionCode_Id.toString(),
-            HoldInstructionExtension.NAME);
+            HoldInstructionExtension.class.getSimpleName());
         mDefaultCRLExtensionIDs.put(PKIXExtensions.InvalidityDate_Id.toString(),
-            InvalidityDateExtension.NAME);
+            InvalidityDateExtension.class.getSimpleName());
         //mDefaultCRLExtensionIDs.put(PKIXExtensions.CertificateIssuer_Id.toString(),
         //                     CertificateIssuerExtension.NAME);
         mDefaultCRLExtensionIDs.put(PKIXExtensions.FreshestCRL_Id.toString(),
-            FreshestCRLExtension.NAME);
+            FreshestCRLExtension.class.getSimpleName());
         mDefaultCRLExtensionIDs.put(AuthInfoAccessExtension.ID.toString(),
             AuthInfoAccessExtension.NAME2);
 
         /* Class names */
-        mDefaultCRLExtensionClassNames.put(AuthorityKeyIdentifierExtension.NAME,
+        mDefaultCRLExtensionClassNames.put(AuthorityKeyIdentifierExtension.class.getSimpleName(),
             "com.netscape.cms.crl.CMSAuthorityKeyIdentifierExtension");
-        mDefaultCRLExtensionClassNames.put(IssuerAlternativeNameExtension.NAME,
+        mDefaultCRLExtensionClassNames.put(IssuerAlternativeNameExtension.class.getSimpleName(),
             "com.netscape.cms.crl.CMSIssuerAlternativeNameExtension");
-        mDefaultCRLExtensionClassNames.put(CRLNumberExtension.NAME,
+        mDefaultCRLExtensionClassNames.put(CRLNumberExtension.class.getSimpleName(),
             "com.netscape.cms.crl.CMSCRLNumberExtension");
-        mDefaultCRLExtensionClassNames.put(DeltaCRLIndicatorExtension.NAME,
+        mDefaultCRLExtensionClassNames.put(DeltaCRLIndicatorExtension.class.getSimpleName(),
             "com.netscape.cms.crl.CMSDeltaCRLIndicatorExtension");
-        mDefaultCRLExtensionClassNames.put(IssuingDistributionPointExtension.NAME,
+        mDefaultCRLExtensionClassNames.put(IssuingDistributionPointExtension.class.getSimpleName(),
             "com.netscape.cms.crl.CMSIssuingDistributionPointExtension");
-        mDefaultCRLExtensionClassNames.put(CRLReasonExtension.NAME,
+        mDefaultCRLExtensionClassNames.put(CRLReasonExtension.class.getSimpleName(),
             "com.netscape.cms.crl.CMSCRLReasonExtension");
-        mDefaultCRLExtensionClassNames.put(HoldInstructionExtension.NAME,
+        mDefaultCRLExtensionClassNames.put(HoldInstructionExtension.class.getSimpleName(),
             "com.netscape.cms.crl.CMSHoldInstructionExtension");
-        mDefaultCRLExtensionClassNames.put(InvalidityDateExtension.NAME,
+        mDefaultCRLExtensionClassNames.put(InvalidityDateExtension.class.getSimpleName(),
             "com.netscape.cms.crl.CMSInvalidityDateExtension");
         //mDefaultCRLExtensionClassNames.put(CertificateIssuerExtension.NAME,
         //        "com.netscape.cms.crl.CMSCertificateIssuerExtension");
-        mDefaultCRLExtensionClassNames.put(FreshestCRLExtension.NAME,
+        mDefaultCRLExtensionClassNames.put(FreshestCRLExtension.class.getSimpleName(),
             "com.netscape.cms.crl.CMSFreshestCRLExtension");
         mDefaultCRLExtensionClassNames.put(AuthInfoAccessExtension.NAME2,
             "com.netscape.cms.crl.CMSAuthInfoAccessExtension");
@@ -166,25 +166,25 @@ public class CMSCRLExtensions implements ICMSCRLExtensions {
         try {
             OIDMap.addAttribute(DeltaCRLIndicatorExtension.class.getName(),
                 DeltaCRLIndicatorExtension.OID,
-                DeltaCRLIndicatorExtension.NAME);
+                DeltaCRLIndicatorExtension.class.getSimpleName());
         } catch (CertificateException e) {
         }
         try {
             OIDMap.addAttribute(HoldInstructionExtension.class.getName(),
                 HoldInstructionExtension.OID,
-                HoldInstructionExtension.NAME);
+                HoldInstructionExtension.class.getSimpleName());
         } catch (CertificateException e) {
         }
         try {
             OIDMap.addAttribute(InvalidityDateExtension.class.getName(),
                 InvalidityDateExtension.OID,
-                InvalidityDateExtension.NAME);
+                InvalidityDateExtension.class.getSimpleName());
         } catch (CertificateException e) {
         }
         try {
             OIDMap.addAttribute(FreshestCRLExtension.class.getName(),
                 FreshestCRLExtension.OID,
-                FreshestCRLExtension.NAME);
+                FreshestCRLExtension.class.getSimpleName());
         } catch (CertificateException e) {
         }
     }
@@ -605,7 +605,7 @@ public class CMSCRLExtensions implements ICMSCRLExtensions {
 
                 CMSCRLExtensions cmsCRLExtensions = (CMSCRLExtensions) ip.getCRLExtensions();
                 if(cmsCRLExtensions != null) {
-                    issuingDistPointExtEnabled =  cmsCRLExtensions.isCRLExtensionEnabled(IssuingDistributionPointExtension.NAME); 
+                    issuingDistPointExtEnabled =  cmsCRLExtensions.isCRLExtensionEnabled(IssuingDistributionPointExtension.class.getSimpleName()); 
                 }
 
                 CMS.debug("issuingDistPointExtEnabled = " + issuingDistPointExtEnabled);
